Index: /readTracFiles_mod.f90
===================================================================
--- /readTracFiles_mod.f90	(revision 1)
+++ /readTracFiles_mod.f90	(revision 2)
@@ -1162,8 +1164,8 @@
 LOGICAL FUNCTION getKeyByName_sm(keyn, val, tnam, ky) RESULT(lerr)
   CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
-  CHARACTER(LEN=256),    ALLOCATABLE, INTENT(OUT) ::  val(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) ::  val(:)
   CHARACTER(LEN=*), TARGET, OPTIONAL, INTENT(IN)  :: tnam(:)
-  TYPE(kys),        TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
-  CHARACTER(LEN=256), POINTER :: n(:)
+  TYPE(keys_type),  TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen),    POINTER :: n(:)
   INTEGER :: iq
   n => tracers(:)%keys%name; IF(PRESENT(tnam)) n => tnam(:)
@@ -1174,15 +1176,15 @@
 !==============================================================================================================================
 LOGICAL FUNCTION getKeyByName_i1(keyn, val, tnam, ky) RESULT(lerr)
-  CHARACTER(LEN=*),    INTENT(IN)  :: keyn
-  INTEGER,             INTENT(OUT) :: val
-  CHARACTER(LEN=*),    INTENT(IN)  :: tnam
-  TYPE(kys), OPTIONAL, INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=256) :: sval
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  INTEGER,                   INTENT(OUT) :: val
+  CHARACTER(LEN=*),          INTENT(IN)  :: tnam
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=maxlen) :: sval
   INTEGER :: ierr
   IF(     PRESENT(ky)) lerr = getKeyByName_s1(keyn, sval, tnam, ky)
   IF(.NOT.PRESENT(ky)) lerr = getKeyByName_s1(keyn, sval, tnam)
-  IF(test(fmsg(lerr,   'key "'//TRIM(keyn)//'" or tracer "'//TRIM(tnam)//'" is missing'),        lerr)) RETURN
+  IF(test(fmsg('key "'//TRIM(keyn)//'" or tracer "'//TRIM(tnam)//'" is missing',        modname, lerr), lerr)) RETURN
   READ(sval, *, IOSTAT=ierr) val
-  IF(test(fmsg(ierr/=0,'key "'//TRIM(keyn)//'" of tracer "'//TRIM(tnam)//'" is not an integer'), lerr)) RETURN
+  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tnam)//'" is not an integer', modname, lerr), lerr)) RETURN
 END FUNCTION getKeyByName_i1
 !==============================================================================================================================
@@ -1191,6 +1193,6 @@
   INTEGER,               ALLOCATABLE, INTENT(OUT) ::  val(:)
   CHARACTER(LEN=*), TARGET, OPTIONAL, INTENT(IN)  :: tnam(:)
-  TYPE(kys),        TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
-  CHARACTER(LEN=256), POINTER :: n(:)
+  TYPE(keys_type),  TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), POINTER :: n(:)
   INTEGER :: iq
   n => tracers(:)%name; IF(PRESENT(tnam)) n => tnam(:)
@@ -1201,15 +1203,15 @@
 !==============================================================================================================================
 LOGICAL FUNCTION getKeyByName_r1(keyn, val, tnam, ky) RESULT(lerr)
-  CHARACTER(LEN=*),    INTENT(IN)  :: keyn
-  REAL,                INTENT(OUT) :: val
-  CHARACTER(LEN=*),    INTENT(IN)  :: tnam
-  TYPE(kys), OPTIONAL, INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=256) :: sval
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  REAL,                      INTENT(OUT) :: val
+  CHARACTER(LEN=*),          INTENT(IN)  :: tnam
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=maxlen) :: sval
   INTEGER :: ierr
   IF(     PRESENT(ky)) lerr = getKeyByName_s1(keyn, sval, tnam, ky)
   IF(.NOT.PRESENT(ky)) lerr = getKeyByName_s1(keyn, sval, tnam)
-  IF(test(fmsg(lerr,   'key "'//TRIM(keyn)//'" or tracer "'//TRIM(tnam)//'" is missing'),    lerr)) RETURN
+  IF(test(fmsg('key "'//TRIM(keyn)//'" or tracer "'//TRIM(tnam)//'" is missing',    modname, lerr), lerr)) RETURN
   READ(sval, *, IOSTAT=ierr) val
-  IF(test(fmsg(ierr/=0,'key "'//TRIM(keyn)//'" of tracer "'//TRIM(tnam)//'" is not a real'), lerr)) RETURN
+  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tnam)//'" is not a real', modname, lerr), lerr)) RETURN
 END FUNCTION getKeyByName_r1
 !==============================================================================================================================
@@ -1218,6 +1220,6 @@
   REAL,                  ALLOCATABLE, INTENT(OUT) ::  val(:)
   CHARACTER(LEN=*), TARGET, OPTIONAL, INTENT(IN)  :: tnam(:)
-  TYPE(kys),        TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
-  CHARACTER(LEN=256), POINTER :: n(:)
+  TYPE(keys_type),  TARGET, OPTIONAL, INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), POINTER :: n(:)
   INTEGER :: iq
   n => tracers(:)%name;  IF(PRESENT(tnam)) n => tnam(:)
@@ -1232,5 +1234,5 @@
 !=== REMOVE, IF ANY, OR ADD THE PHASE SUFFIX OF THE TRACER NAMED "s" ==========================================================
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION delPhase(s) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION delPhase(s) RESULT(out)
   CHARACTER(LEN=*), INTENT(IN) :: s
   INTEGER :: l, i, ix
@@ -1249,5 +1251,5 @@
 END FUNCTION delPhase
 !------------------------------------------------------------------------------------------------------------------------------
-CHARACTER(LEN=256) FUNCTION addPhase_1(s,pha) RESULT(out)
+CHARACTER(LEN=maxlen) FUNCTION addPhase_1(s,pha) RESULT(out)
   CHARACTER(LEN=*), INTENT(IN) :: s
   CHARACTER(LEN=1), INTENT(IN) :: pha
@@ -1262,7 +1264,7 @@
 !------------------------------------------------------------------------------------------------------------------------------
 FUNCTION addPhase_m(s,pha) RESULT(out)
-  CHARACTER(LEN=*),    INTENT(IN) :: s(:)
-  CHARACTER(LEN=1),    INTENT(IN) :: pha
-  CHARACTER(LEN=256), ALLOCATABLE :: out(:)  
+  CHARACTER(LEN=*),      INTENT(IN)  :: s(:)
+  CHARACTER(LEN=1),      INTENT(IN)  :: pha
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: out(:)  
   INTEGER :: k
   out = [( addPhase_1(s(k), pha), k=1, SIZE(s) )]
@@ -1274,6 +1276,6 @@
 !=== GET THE NAME(S) OF THE ANCESTOR(S) OF TRACER(S) "tname" AT GENERATION "igen"  IN THE TRACERS DESCRIPTORS LIST "tr" =======
 !==============================================================================================================================
-CHARACTER(LEN=256) FUNCTION ancestor_1(t, tname, igen) RESULT(out)
-  TYPE(tra),         INTENT(IN) :: t(:)
+CHARACTER(LEN=maxlen) FUNCTION ancestor_1(t, tname, igen) RESULT(out)
+  TYPE(trac_type),   INTENT(IN) :: t(:)
   CHARACTER(LEN=*),  INTENT(IN) :: tname
   INTEGER, OPTIONAL, INTENT(IN) :: igen
@@ -1285,6 +1287,6 @@
 !------------------------------------------------------------------------------------------------------------------------------
 FUNCTION ancestor_m(t, tname, igen) RESULT(out)
-  CHARACTER(LEN=256), ALLOCATABLE        ::   out(:)
-  TYPE(tra),                  INTENT(IN) ::     t(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE     ::   out(:)
+  TYPE(trac_type),            INTENT(IN) ::     t(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: tname(:)
   INTEGER,          OPTIONAL, INTENT(IN) :: igen
@@ -1305,5 +1307,5 @@
 INTEGER FUNCTION idxAncestor_1(t, tname, igen) RESULT(out)
 ! Return the name of the generation "igen" ancestor of "tname"
-  TYPE(tra),         INTENT(IN) :: t(:)
+  TYPE(trac_type),   INTENT(IN) :: t(:)
   CHARACTER(LEN=*),  INTENT(IN) :: tname
   INTEGER, OPTIONAL, INTENT(IN) :: igen
@@ -1312,11 +1314,11 @@
   out = strIdx(t(:)%name, tname)
   IF(out == 0)          RETURN
-  IF(t(out)%igen <= ig) RETURN
-  DO WHILE(t(out)%igen > ig); out = strIdx(t(:)%name, t(out)%prnt); END DO
+  IF(t(out)%iGeneration <= ig) RETURN
+  DO WHILE(t(out)%iGeneration > ig); out = strIdx(t(:)%name, t(out)%parent); END DO
 END FUNCTION idxAncestor_1
 !------------------------------------------------------------------------------------------------------------------------------
 FUNCTION idxAncestor_m(t, tname, igen) RESULT(out)
   INTEGER,          ALLOCATABLE          ::   out(:)
-  TYPE(tra),                  INTENT(IN) ::     t(:)
+  TYPE(trac_type),            INTENT(IN) ::     t(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: tname(:)
   INTEGER,          OPTIONAL, INTENT(IN) :: igen
